#ifndef UNICODE
#define UNICODE
#endif

#pragma comment(lib, "netapi32.lib")

#include <stdio.h>
#include <windows.h> 
#include <lm.h>

int wmain(int argc, wchar_t *argv[])
{
   DWORD dwError = 0;
   NET_API_STATUS nStatus;

   // All parameters are required.
   if (argc != 5)
   {
      fwprintf_s(stderr, L"Usage: %s \\\\ServerName UserName OldPassword NewPassword\n", argv[0]);
	  wprintf(L"Example: %s \\\\MikeServer \"Mike Tyson\" 1234 4321\n", argv[0]);
      exit(1);
   }

   // Call the NetUserChangePassword() function.
   nStatus = NetUserChangePassword(argv[1], argv[2], argv[3], argv[4]);

   // If the call succeeds, inform the user.
   if (nStatus == NERR_Success)
   {
	   wprintf(L"NetUserChangePassword() is OK!\n");
	   fwprintf_s(stderr, L"User password has been changed successfully\n");
   }
   // Otherwise, print the system error.
   else
   {
	   wprintf(L"NetUserChangePassword() failed!\n");
	   fwprintf_s(stderr, L"A system error has occurred: %d\n", nStatus);
   }

   return 0;
}
